#include <iostream>
#include <list>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
//
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
using namespace std;

#include "e0g-pqe+.hh"
#include "einline.hh"

//
//   MARK_AS_REDUND
//
void ExQuant::mark_as_redund()
{

  for (uint i=init_ncubes; i < F.size(); i++) {
    if (Cube_info[i].type == Y_CUBE) continue;
    if (Cube_info[i].state == REDUNDANT) {
      if (Red_cube_depth[i] == -1)
        continue;
    }
    mark_glob_red(i);
  }

} /* mark_as_redund */

//
//  INIT_SGNL_CUBES
//
void ExQuant::init_sgnl_cubes()
{

 
  for (uint i=0; i < F.size(); i++) 
    Cube_info[i].signal = 0;

  SCUBE::iterator pnt;
  SCUBE &S = Curr_prim_scubes;
  assert(S.size() > 0);
  num_act_sgnl_cubes = 0;
  
  for (pnt = S.begin(); pnt != S.end(); pnt++) {
    int cube_ind = *pnt; 
    CubeInfo &El = Cube_info[cube_ind];
    if (El.state == ACTIVE) {
      El.signal = 1;
      El.depth = -1;
      num_act_sgnl_cubes++;
    }
    else {
      assert(El.state == REDUNDANT);
      assert(Red_cube_depth[cube_ind] < 0);
      El.signal = 0;
      El.depth = num_vars+1;
    }
  }

  Sgnl_xvars.clear();
  Sgnl_yvars.clear();
  for (int i=0; i < num_vars; i++)
    Var_state[i].in_array = 0;
  set_init_counts();

  num_sgnl_xvars = Sgnl_xvars.size();
  num_sgnl_yvars = Sgnl_yvars.size();

  curr_num_sgnl_cubes = num_act_sgnl_cubes;

} /* init_sgnl_cubes */


//
//   UPD_PRIM_CUBES_INFO
//
void ExQuant::upd_prim_cubes_info(int cube_ind)
{  
  mark_glob_red(cube_ind);
   
  Prim_sgnl_cubes.pop_back();

} /* upd_prim_cubes_info */

//
//    MARK_GLOB_RED
//
void ExQuant::mark_glob_red(int cube_ind)
{

  Cube_info[cube_ind].state = REDUNDANT;
  Cube_info[cube_ind].signal = 0;
  Cause_lit[cube_ind] = 0;
  Red_cube_depth[cube_ind] = -1;


} /* mark_glob_red */

//
//   ADD_CAUSE_LIT
//
void ExQuant::add_cause_lit(CUBE &B,int cube_ind)
{

  int lit = Cause_lit[cube_ind];
  B.push_back(lit);

} /* add_cause_lit */


