#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
#include "System.h"
using namespace std;
#include "e0g-pqe+.hh"
#include "einline.hh"


/*========================================

  P R I N T _ Y V A R _ M O D E

  =========================================*/
void ExQuant::print_yvar_mode(int num_spaces)
{
  for (int i=0; i < num_spaces; i++) printf(" ");
  if (yvar_mode) printf("YVAR-MODE\n");
  else printf("XVAR-MODE\n");


} /* end of function print_yvar_mode */


/*=======================================

  P R I N T _ P I N G _ R O W

  Prints cubes protecting cube 'cube_ind'

  ========================================*/
void ExQuant::print_ping_row(int cube_ind)
{
  CUBE &C = F[cube_ind];
  printf("Cubes protecting cube %d: ",cube_ind);
  for (uint i=0; i < C.size(); i++)   {
    int var_ind = abs(C[i])-1;
    if (i!=0) printf(", ");
    if (Var_state[var_ind].xvar == 0)
      printf("*");
    else 
      printf("C%d",Ping[cube_ind][i]);
  }
  printf("\n");
} /* end of function print_ping_row */

/*=============================

  P R I N T _ P I N G

  ==============================*/
void ExQuant::print_ping()
{

  printf("\nARRAY Ping:\n");
  for (uint i=0; i < F.size(); i++)    {     
    if (Cube_info[i].signal == 0) continue;
    print_ping_row(i);
  }
} /* end of function print_ping */

/*=============================

  P R I N T _ N O D E

  ==============================*/
void ExQuant::print_node(Node &n)
{
  printf("var = %d\n",n.var);
  printf("lval = %d\n",n.lval);
  
  if (n.branch == LEFT) printf("LEFT branch\n");
  else   {
    printf("RIGHT branch\n");
    printf("left branch time is %d\n",Formula_size[n.var-1]);
  }
  printf("left_child_cube = %d\n",n.left_ecube);
  printf("right_ecube = %d\n",n.right_ecube);

} /* end of function print_node */

/*=============================

  P R I N T _ T R E E _ P A T H

  ==============================*/
void ExQuant::print_tree_path()
{

  
  assert(curr_depth + 1 == (int) Tree_path.size());

  printf("Tree_path.size() = %d\n",(int) Tree_path.size());
  for (int i=0; i <= curr_depth; i++) {
    printf("--------------------------");
    printf("node of depth %d\n",i);
    print_node(Tree_path[i]);
  }

 
} /* end of function print_tree_path */
