#include <iostream>
#include <list>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
//
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
using namespace std;

#include "e0g-pqe+.hh"
#include "einline.hh"

//
//  FORM_ADD_CLAUSES
//
void ExQuant::form_add_clauses(DNF &H)
{

  SCUBE::iterator pnt;

  int shift = 1;
  SCUBE &S = Curr_prim_scubes;
  CUBE Last;
  for (pnt = S.begin(); pnt != S.end(); pnt++,shift++) {
    int cube_ind = *pnt;
    CUBE C = F[cube_ind];
    for (uint i=0; i < C.size(); i++) {
      CUBE B;
      B.push_back(-C[i]);
      B.push_back(num_vars+shift);
      H.push_back(B);     
    }
 
    C.push_back(-(num_vars+shift));
    H.push_back(C);
    Last.push_back(-(num_vars+shift));
  }

  H.push_back(Last);
} /* form_add_clauses */

//
//  ADD_SAT_XLIT
//
void ExQuant::add_sat_xlit(CLAUSE &B,CLAUSE &C)
{

  MboolVec &S = Slv->model;
  for (uint i=0; i < C.size(); i++) {
    int var_ind = abs(C[i])-1;
    if (Xvar[var_ind] == 0) continue;
    int lit = var_ind+1;
    if (S[var_ind] != Mtrue)
      lit = -lit;
    if (C[i] == lit) {
      B.push_back(C[i]);
      return;      
    }
  }
  p();
  print_cube1(B);
  print_cube1(C);
  CUBE A;
  form_sat_assgn(A,Slv);
  print_cube1(A);
  exit(ERROR);
  
} /* add_sat_xlit */




//
// GEN_IMPL_CLS
//
void ExQuant::gen_impl_cls(CLAUSE &D,MvecLits &Assmps)
{
  
  for (int i=0; i < Assmps.size(); i++) {
    Mlit L = ~Assmps[i];   
    if (Slv->conflict.has(L)) {
      int lit = mlit_to_lit(Slv,L);
      D.push_back(lit);
    }
  }
        
} /* gen_impl_cls */




