#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <time.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

#include "Solver.h"
#include "SimpSolver.h"
#include "System.h"
using namespace std;
#include "e0g-pqe+.hh"


/*=========================

  G E T _ R U N T I M E
  
  =========================*/
void get_runtime (double &usrtime, double &systime)
{
  struct rusage timeusage;

  getrusage(RUSAGE_SELF, &timeusage);

  usrtime = (double)timeusage.ru_utime.tv_sec  + (double)timeusage.ru_utime.tv_usec / 1000000;
  systime = (double)timeusage.ru_stime.tv_sec  + (double)timeusage.ru_stime.tv_usec / 1000000;
} /* end of function get_runtime */

/*=========================

  S E T _ V E R B O S E

  ========================*/
void  ExQuant::set_verbose()
{


  if (start_gcount < 0) return;

  if (range_gcount < 0) {
    if (gcount >= start_gcount) {
      verbose = true;
      return;
    }
    else
      return;
  }

  if (gcount < start_gcount - range_gcount)
    return;

  if (gcount > start_gcount + range_gcount) {
    verbose = false;
    return;
  }

  verbose = true;


} /* end of function set_verbose */

/*==============================================

  I N I T I A L I Z E _ C U B E _ V E C T S

  ===============================================*/
void initialize_cube_vects(DNF &A,DNF & Lits0,DNF &Lits1)

{unsigned int i,j;
  int lit;


  for (i=0; i < A.size();i++) {
    CUBE &cube = A[i];
    for (j = 0; j < cube.size();j++) {
      lit = cube[j];
      if (lit < 0)
        Lits0[(-1*lit)-1].push_back(i); // add cube index
      else
        Lits1[lit-1].push_back(i); // add cube index
    }
  }
} /* end of function initialize_cube_vects */
